<template>
  <div class="ob-datetime-mobile__modal">
    <div class="ob-datetime-mobile__header">
      <i
        class="icon chevron-left"
        @click="$emit('close', null)"
      />
      Выберите дату и время
    </div>
    <div class="ob-datetime-mobile__container">
      <div
        v-for="(type, index) in typesOfShipment"
        :key="index"
        class="ob-datetime-mobile__container-radio"
      >
        <ObRadio
          v-model="typeOfShipment"
          :label="type.label"
          :value-input="type.value"
          :disabled="type.disabled"
          :class="{
            __active: typeOfShipment === type.value
          }"
        />
      </div>
      <div class="ob-datetime-mobile__container--title">
        Дата и время
      </div>
      <div class="ob-datetime-mobile__content">
        <obInput
          v-model="dateValue"
          class="input__date"
          placeholder="дд.мм.гггг"
          label="Дата"
          @click.native="dateModal = true"
        />
        <obInput
          v-model="timeValue"
          :mask="'чч:мм'"
          class="input__time"
          placeholder="чч.мм"
          label="Время"
          icon="chevron-down"
          @on-click-icon="timeModal = true"
        />
      </div>
    </div>
    <div class="ob-datetime-mobile__footer">
      <obButton
        class="ob-datetime-mobile__footer--button"
        :label="buttonText"
        :disabled="!hasPeriodCompleted"
        @click="onSubmitForm"
      />
    </div>
    <ModalDate
      v-if="dateModal"
      :date="dateValue"
      :disabled-dates="disabledDates"
      @close="closeDateModal"
    />
    <ModalTime
      v-if="timeModal"
      @close="closeTimeModal"
    />
  </div>
</template>

<script>
import obInput from '../obInput'
import ObRadio from '../obRadio'
import obButton from '../obButton'
import ModalDate from './ModalDate'
import ModalTime from './ModalTime'
import moment from 'moment'
export default {
  name: 'DateDescription',
  components: {
    obInput,
    ObRadio,
    obButton,
    ModalDate,
    ModalTime
  },
  props: {
    period: {
      type: String,
      default: ''
    },
    typesOfShipment: {
      type: Array,
      default: () => []
    },
    selectedTypeOfShipment: {
      type: String,
      default: 'loading'
    },
    buttonText: {
      type: String,
      default: 'Выбрать'
    },
    disabledDates: {
      type: Object,
      default: () => ({
        to: '',
        from: ''
      })
    }
  },
  data () {
    return {
      typeOfShipment: this.selectedTypeOfShipment,
      dateValue: '',
      timeValue: '',
      dateModal: false,
      timeModal: false
    }
  },
  computed: {
    hasPeriodCompleted () {
      return Boolean(this.dateValue && this.timeValue)
    }
  },
  mounted () {
    if (this.period) {
      this.dateValue = this.period.substring(0, 10)
      this.timeValue = this.period.substring(12, 17)
    }
  },
  methods: {
    onSubmitForm () {
      const data = {
        period: this.formatter(),
        shipment: this.selectedTypeOfShipment
      }
      this.$emit('close', data)
    },
    formatter () {
      return moment(this.dateValue + this.formatTime(this.timeValue), 'DD.MM.YYYYHH:mm')
        .format('YYYY-MM-DDTHH:mm:ss.SS[Z]')
    },
    formatTime (time) {
      if (time.indexOf(':') !== -1) {
        return time
      } else {
        time = time.substring(0, 2) + ':' + time.substring(2, 4)
        return time
      }
    },
    closeDateModal (date) {
      if (date !== null) {
        this.dateValue = moment(date).format('DD.MM.YYYY')
      }
      this.dateModal = false
    },
    closeTimeModal (time) {
      if (time !== null) {
        this.timeValue = time
      }
      this.timeModal = false
    }
  }
}
</script>
